## qlcplus 4.14.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(qlcplus VERSION 4.14.1 LANGUAGES C CXX)

# Set Release build type by default
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# Prevent CMake make install strips off non-standard build paths
# Refer to https://stackoverflow.com/questions/7970544/cmake-make-install-output-cant-find-shared-qt-libraries-under-redhat
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

SET(INSTALL_ROOT "/" CACHE STRING "Installation root directory")

if(UNIX)
    if (APPLE)
        set(iokit ON)
    else()
        set(udev ON)
    endif()
endif()

if (ANDROID OR IOS)
    set(qmlui ON)
endif()

if (ANDROID)
    if(QT_VERSION_MAJOR GREATER 5)
        set(QT_ANDROID_PACKAGE_SOURCE_DIR ${PROJECT_SOURCE_DIR}/platforms/android CACHE INTERNAL "")
    else()
        set(ANDROID_PACKAGE_SOURCE_DIR ${PROJECT_SOURCE_DIR}/platforms/android CACHE INTERNAL "")
    endif()
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Set up AUTOMOC and some sensible defaults for runtime execution
# When using Qt 6.3, you can replace the code block below with
# qt_standard_project_setup()
set(CMAKE_AUTOMOC ON)
include(GNUInstallDirs)

find_package(QT NAMES Qt5 Qt6 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui Multimedia MultimediaWidgets Network PrintSupport Qml Quick Svg Test Widgets LinguistTools)
if(qmlui)
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS 3DCore 3DInput 3DQuick 3DQuickExtras 3DRender)
    if(ANDROID)
        find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Concurrent OpenGL)
    endif()
endif()

message("Found Qt version ${QT_VERSION_MAJOR}: ${QT_DIR}")

if(QT_VERSION_MAJOR EQUAL 5)
    find_package(Qt${QT_VERSION_MAJOR} OPTIONAL_COMPONENTS Script)
endif()

find_package(PkgConfig REQUIRED)

include(./variables.cmake)
include(./coverage.cmake)

if((((QT_VERSION_MAJOR LESS 5)) AND (APPLE)))
    pkg_check_modules(PORTAUDIO_2 IMPORTED_TARGET portaudio-2.0)
endif()

if(WIN32)
    # Prefix all shared libraries with ''.
    set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif()

add_subdirectory(hotplugmonitor)
add_subdirectory(engine)
add_subdirectory(resources)
add_subdirectory(plugins)
if(qmlui)
    message("Building QLC+ 5 QML UI")
    add_subdirectory(qmlui)
else()
    message("Building QLC+ 4 QtWidget UI")
    add_subdirectory(ui)
    add_subdirectory(webaccess)
    add_subdirectory(main)
    add_subdirectory(fixtureeditor)
endif()
if(APPLE AND NOT qmlui)
    add_subdirectory(launcher)
endif()

# Unit testing thru "make check"
if(qmlui)
    if(WIN32)
       add_custom_target(unittests
            COMMAND unittest_cmake.bat "qmlui" ${CMAKE_CURRENT_BINARY_DIR}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    else()
       add_custom_target(unittests
            COMMAND ./unittest_cmake.sh "qmlui" ${CMAKE_CURRENT_BINARY_DIR}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    endif()
else()
    if(WIN32)
       add_custom_target(unittests
            COMMAND unittest_cmake.bat "ui" ${CMAKE_CURRENT_BINARY_DIR}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    else()
       add_custom_target(unittests
            COMMAND ./unittest_cmake.sh "ui" ${CMAKE_CURRENT_BINARY_DIR}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    endif()
endif()

add_custom_target(check
    DEPENDS unittests
)

# Unit test coverage measurement
if(WIN32)
    add_custom_target(coverage
        COMMAND @echo Get a better OS.
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
else()
    if(qmlui)
       add_custom_target(coverage
            COMMAND ./coverage_cmake.sh "qmlui"
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    else()
       add_custom_target(coverage
            COMMAND ./coverage_cmake.sh "ui"
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    endif()
endif()

add_custom_target(lcov
    DEPENDS coverage
)

# Translations
if (qmlui)
  add_custom_target(translations ALL
    COMMAND ./translate.sh "qmlui"
    COMMENT "Translating qmlui translations..."
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
else ()
  add_custom_target(translations ALL
    COMMAND ./translate.sh "ui"
    COMMENT "Translating ui translations..."
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

## Install the qm files
if (appimage)
  set(translations_install_path "${TARGET_DIR}/${INSTALLROOT}/${TRANSLATIONDIR}")
else ()
  set(translations_install_path "${INSTALLROOT}/${TRANSLATIONDIR}")
endif()

# Define the pattern for the .qm files
set(translations_qm_pattern "${CMAKE_CURRENT_SOURCE_DIR}/qlcplus_*.qm")

# Install command using a custom script
install(CODE "
  file(GLOB qm_files \"${translations_qm_pattern}\")
  foreach(file IN LISTS qm_files)
    file(INSTALL DESTINATION \"${translations_install_path}\" TYPE FILE FILES \"\${file}\")
  endforeach()
" COMPONENT translations)

## Clean the generated files
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_BINARY_DIR}/*.qm")

# run
if(UNIX)
    if(qmlui)
       add_custom_target(run
            COMMAND ${CMAKE_COMMAND} -E env LD_LIBRARY_PATH=engine/src:$ENV{LD_LIBRARY_PATH} qmlui/qlcplus-qml
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    else()
       add_custom_target(run
            COMMAND ${CMAKE_COMMAND} -E env LD_LIBRARY_PATH=engine/src:ui/src:webaccess/src:$ENV{LD_LIBRARY_PATH} main/qlcplus
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    endif()
endif()

# run-fxe
if(UNIX AND NOT qmlui)
    add_custom_target(run-fxe
        COMMAND ${CMAKE_COMMAND} -E env LD_LIBRARY_PATH=engine/src:ui/src:webaccess/src:$ENV{LD_LIBRARY_PATH} ./fixtureeditor/qlcplus-fixtureeditor
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    )
endif()

# doxygen
if(UNIX)
    add_custom_target(doxygen
        COMMAND cd resources/doxygen && rm -rf html/ && doxygen qlcplus.dox
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
endif()

# uninstall target
if(NOT TARGET uninstall)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

  add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

SET(CPACK_GENERATOR "DEB")
set(CPACK_PACKAGE_NAME "qlcplus")
SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Massimo Callegari") #required
INCLUDE(CPack)

# Leave this on the last row of this file
add_subdirectory(platforms)

# HELPER: PRINT ALL VARIABLES KNOWN BY CMAKE

#message("QTDIR: ${QT_DIR}")
#get_cmake_property(_variableNames VARIABLES)
#list (SORT _variableNames)
#foreach (_variableName ${_variableNames})
#    message(STATUS "${_variableName}=${${_variableName}}")
#endforeach()

=== fixtureeditor/CMakeLists.txt ===
set(module_name "qlcplus-fixtureeditor")

set(TS_FILES
    fixtureeditor_fi_FI.ts
    fixtureeditor_fr_FR.ts
    fixtureeditor_de_DE.ts
    fixtureeditor_es_ES.ts
    fixtureeditor_it_IT.ts
    fixtureeditor_nl_NL.ts
    fixtureeditor_cz_CZ.ts
    fixtureeditor_pt_BR.ts
    fixtureeditor_ca_ES.ts
    fixtureeditor_ja_JP.ts
)

if(QT_VERSION_MAJOR GREATER 5)
    qt_add_translation(QM_FILES ${TS_FILES})
else()
    qt5_add_translation(QM_FILES ${TS_FILES})
endif()

add_executable(${module_name} WIN32
    ../ui/src/aboutbox.cpp ../ui/src/aboutbox.h ../ui/src/aboutbox.ui
    ../ui/src/apputil.cpp ../ui/src/apputil.h
    ../ui/src/docbrowser.cpp ../ui/src/docbrowser.h
    addchannelsdialog.cpp addchannelsdialog.h addchannelsdialog.ui
    app.cpp app.h
    capabilitywizard.cpp capabilitywizard.h capabilitywizard.ui
    editchannel.cpp editchannel.h editchannel.ui
    edithead.cpp edithead.h edithead.ui
    editmode.cpp editmode.h editmode.ui
    editphysical.cpp editphysical.h editphysical.ui
    fixtureeditor.cpp fixtureeditor.h fixtureeditor.ui
    main.cpp
    util.h
    ${QM_FILES}
)

target_include_directories(${module_name} PRIVATE
    ../engine/src
    ../plugins/interfaces
    ../ui/src
)

target_link_libraries(${module_name} PRIVATE
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Widgets
    qlcplusengine
)


# Resources:
set_source_files_properties("../ui/src/../../resources/icons/png/add_dump.png"
    PROPERTIES QT_RESOURCE_ALIAS "add_dump.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/animation.png"
    PROPERTIES QT_RESOURCE_ALIAS "animation.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/attach.png"
    PROPERTIES QT_RESOURCE_ALIAS "attach.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/audio.png"
    PROPERTIES QT_RESOURCE_ALIAS "audio.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/audioinput.png"
    PROPERTIES QT_RESOURCE_ALIAS "audioinput.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/autostart.png"
    PROPERTIES QT_RESOURCE_ALIAS "autostart.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/back.png"
    PROPERTIES QT_RESOURCE_ALIAS "back.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/beam.png"
    PROPERTIES QT_RESOURCE_ALIAS "beam.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/blackout.png"
    PROPERTIES QT_RESOURCE_ALIAS "blackout.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/blind.png"
    PROPERTIES QT_RESOURCE_ALIAS "blind.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/button.png"
    PROPERTIES QT_RESOURCE_ALIAS "button.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/buttonmatrix.png"
    PROPERTIES QT_RESOURCE_ALIAS "buttonmatrix.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/chaser.png"
    PROPERTIES QT_RESOURCE_ALIAS "chaser.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/check.png"
    PROPERTIES QT_RESOURCE_ALIAS "check.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/checkbox_empty.png"
    PROPERTIES QT_RESOURCE_ALIAS "checkbox_empty.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/checkbox_full.png"
    PROPERTIES QT_RESOURCE_ALIAS "checkbox_full.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/clock.png"
    PROPERTIES QT_RESOURCE_ALIAS "clock.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/collection.png"
    PROPERTIES QT_RESOURCE_ALIAS "collection.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/color.png"
    PROPERTIES QT_RESOURCE_ALIAS "color.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/colorwheel.png"
    PROPERTIES QT_RESOURCE_ALIAS "colorwheel.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/configure.png"
    PROPERTIES QT_RESOURCE_ALIAS "configure.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/cuelist.png"
    PROPERTIES QT_RESOURCE_ALIAS "cuelist.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/current.png"
    PROPERTIES QT_RESOURCE_ALIAS "current.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/delete.png"
    PROPERTIES QT_RESOURCE_ALIAS "delete.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/design.png"
    PROPERTIES QT_RESOURCE_ALIAS "design.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/detach.png"
    PROPERTIES QT_RESOURCE_ALIAS "detach.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/dimmer.png"
    PROPERTIES QT_RESOURCE_ALIAS "dimmer.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/diptool.png"
    PROPERTIES QT_RESOURCE_ALIAS "diptool.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/down.png"
    PROPERTIES QT_RESOURCE_ALIAS "down.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_border.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_border.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_bottom.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_bottom.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_off.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_off.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_on.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_on.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_top.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_top.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/edit.png"
    PROPERTIES QT_RESOURCE_ALIAS "edit.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/edit_add.png"
    PROPERTIES QT_RESOURCE_ALIAS "edit_add.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/edit_remove.png"
    PROPERTIES QT_RESOURCE_ALIAS "edit_remove.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editclear.png"
    PROPERTIES QT_RESOURCE_ALIAS "editclear.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editcopy.png"
    PROPERTIES QT_RESOURCE_ALIAS "editcopy.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editcopyall.png"
    PROPERTIES QT_RESOURCE_ALIAS "editcopyall.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editcut.png"
    PROPERTIES QT_RESOURCE_ALIAS "editcut.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editdelete.png"
    PROPERTIES QT_RESOURCE_ALIAS "editdelete.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editpaste.png"
    PROPERTIES QT_RESOURCE_ALIAS "editpaste.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/effect.png"
    PROPERTIES QT_RESOURCE_ALIAS "effect.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/efx.png"
    PROPERTIES QT_RESOURCE_ALIAS "efx.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/exit.png"
    PROPERTIES QT_RESOURCE_ALIAS "exit.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/expand.png"
    PROPERTIES QT_RESOURCE_ALIAS "expand.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fade.png"
    PROPERTIES QT_RESOURCE_ALIAS "fade.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fan.png"
    PROPERTIES QT_RESOURCE_ALIAS "fan.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fileclose.png"
    PROPERTIES QT_RESOURCE_ALIAS "fileclose.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fileexport.png"
    PROPERTIES QT_RESOURCE_ALIAS "fileexport.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fileimport.png"
    PROPERTIES QT_RESOURCE_ALIAS "fileimport.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/filenew.png"
    PROPERTIES QT_RESOURCE_ALIAS "filenew.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fileopen.png"
    PROPERTIES QT_RESOURCE_ALIAS "fileopen.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/filesave.png"
    PROPERTIES QT_RESOURCE_ALIAS "filesave.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/filesaveas.png"
    PROPERTIES QT_RESOURCE_ALIAS "filesaveas.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fixture.png"
    PROPERTIES QT_RESOURCE_ALIAS "fixture.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/flash.png"
    PROPERTIES QT_RESOURCE_ALIAS "flash.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/flower.png"
    PROPERTIES QT_RESOURCE_ALIAS "flower.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/folder.png"
    PROPERTIES QT_RESOURCE_ALIAS "folder.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fontcolor.png"
    PROPERTIES QT_RESOURCE_ALIAS "fontcolor.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fonts.png"
    PROPERTIES QT_RESOURCE_ALIAS "fonts.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/forward.png"
    PROPERTIES QT_RESOURCE_ALIAS "forward.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/frame.png"
    PROPERTIES QT_RESOURCE_ALIAS "frame.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/frameraised.png"
    PROPERTIES QT_RESOURCE_ALIAS "frameraised.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/framesunken.png"
    PROPERTIES QT_RESOURCE_ALIAS "framesunken.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fullscreen.png"
    PROPERTIES QT_RESOURCE_ALIAS "fullscreen.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/function.png"
    PROPERTIES QT_RESOURCE_ALIAS "function.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/global.png"
    PROPERTIES QT_RESOURCE_ALIAS "global.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/gobo.png"
    PROPERTIES QT_RESOURCE_ALIAS "gobo.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/grid.png"
    PROPERTIES QT_RESOURCE_ALIAS "grid.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/group.png"
    PROPERTIES QT_RESOURCE_ALIAS "group.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/hazer.png"
    PROPERTIES QT_RESOURCE_ALIAS "hazer.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/help.png"
    PROPERTIES QT_RESOURCE_ALIAS "help.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/image.png"
    PROPERTIES QT_RESOURCE_ALIAS "image.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/input.png"
    PROPERTIES QT_RESOURCE_ALIAS "input.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/input_output.png"
    PROPERTIES QT_RESOURCE_ALIAS "input_output.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/intensity.png"
    PROPERTIES QT_RESOURCE_ALIAS "intensity.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/key_bindings.png"
    PROPERTIES QT_RESOURCE_ALIAS "key_bindings.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/knob.png"
    PROPERTIES QT_RESOURCE_ALIAS "knob.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/label.png"
    PROPERTIES QT_RESOURCE_ALIAS "label.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/laser.png"
    PROPERTIES QT_RESOURCE_ALIAS "laser.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ledbar_beams.png"
    PROPERTIES QT_RESOURCE_ALIAS "ledbar_beams.png"
)

=== platforms/linux/CMakeLists.txt ===
project(icons)

set(desktop_FILES qlcplus.desktop)
if(NOT qmlui)
    list(APPEND desktop_FILES qlcplus-fixtureeditor.desktop)
endif()
install(FILES ${desktop_FILES} DESTINATION ${INSTALLROOT}/share/applications/)

set(icons_SRCS ../../resources/icons/png/qlcplus.png)
if(NOT qmlui)
    list(APPEND icons_SRCS ../../resources/icons/png/qlcplus-fixtureeditor.png)
endif()
install(FILES ${icons_SRCS} DESTINATION ${INSTALLROOT}/share/pixmaps/)

install(FILES qlcplus.xml DESTINATION ${INSTALLROOT}/share/mime/packages)

set(appdata_FILES org.qlcplus.QLCPlus.appdata.xml)
if(NOT qmlui)
    list(APPEND appdata_FILES org.qlcplus.QLCPlusFixtureEditor.appdata.xml)
endif()
install(FILES ${appdata_FILES} DESTINATION ${METAINFODIR})

if(NOT qmlui)
    file(GLOB manpages_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.1")
    install(FILES ${manpages_FILES} DESTINATION ${INSTALLROOT}/${MANDIR})
endif()

# install(FILES ../Sample.qxw DESTINATION ${INSTALLROOT}/${DATADIR})
# install(FILES qlcplus-start.sh DESTINATION ${INSTALLROOT}/sbin)

if(appimage)
    if (QT_DIR STREQUAL "/usr/lib/x86_64-linux-gnu/cmake/Qt5")
        set(QT_LIBS_PATH "/usr/lib/x86_64-linux-gnu")
        set(QT_PLUGINS_PATH "/usr/lib/x86_64-linux-gnu/qt5/plugins")
        set(QT_QML_PATH "/usr/lib/x86_64-linux-gnu/qt5/qml")
    else()
        get_filename_component(QT_LIBS_PATH ${QT_DIR}/../../../lib ABSOLUTE)
        get_filename_component(QT_PLUGINS_PATH ${QT_LIBS_PATH}/../plugins ABSOLUTE)
        get_filename_component(QT_QML_PATH ${QT_LIBS_PATH}/../qml ABSOLUTE)
    endif()
    message("QT_LIBS_PATH ${QT_LIBS_PATH}")
    message("QT_PLUGINS_PATH ${QT_PLUGINS_PATH}")
    message("QT_QML_PATH ${QT_QML_PATH}")
    # Qt dependencies
    file(GLOB qtdeps_FILES "${QT_LIBS_PATH}/libicu*")
    install(
        FILES ${qtdeps_FILES}
        DESTINATION ${INSTALLROOT}/${LIBSDIR}
    )

    # Qt Libraries
    set(qtlibs_FILES
        ${QT_LIBS_PATH}/libQt5Core.so.5
        ${QT_LIBS_PATH}/libQt5Script.so.5
        ${QT_LIBS_PATH}/libQt5Network.so.5
        ${QT_LIBS_PATH}/libQt5Gui.so.5
        ${QT_LIBS_PATH}/libQt5Svg.so.5
        ${QT_LIBS_PATH}/libQt5Widgets.so.5
        ${QT_LIBS_PATH}/libQt5OpenGL.so.5
        ${QT_LIBS_PATH}/libQt5Multimedia.so.5
        ${QT_LIBS_PATH}/libQt5MultimediaWidgets.so.5
        ${QT_LIBS_PATH}/libQt5SerialPort.so.5
        ${QT_LIBS_PATH}/libQt5XcbQpa.so.5
        ${QT_LIBS_PATH}/libQt5DBus.so.5
        ${QT_LIBS_PATH}/libQt5WebSockets.so.5
    )
    if(qmlui)
        list(APPEND qtlibs_FILES
            ${QT_LIBS_PATH}/libQt5MultimediaQuick.so.5
            ${QT_LIBS_PATH}/libQt5MultimediaGstTools.so.5
            ${QT_LIBS_PATH}/libQt5Qml.so.5
            ${QT_LIBS_PATH}/libQt5QmlModels.so.5
            ${QT_LIBS_PATH}/libQt5QmlWorkerScript.so.5
            ${QT_LIBS_PATH}/libQt5Quick.so.5
            ${QT_LIBS_PATH}/libQt5QuickControls2.so.5
            ${QT_LIBS_PATH}/libQt5QuickTemplates2.so.5
            ${QT_LIBS_PATH}/libQt53DCore.so.5
            ${QT_LIBS_PATH}/libQt53DExtras.so.5
            ${QT_LIBS_PATH}/libQt53DInput.so.5
            ${QT_LIBS_PATH}/libQt53DLogic.so.5
            ${QT_LIBS_PATH}/libQt53DAnimation.so.5
            ${QT_LIBS_PATH}/libQt53DQuick.so.5
            ${QT_LIBS_PATH}/libQt53DQuickExtras.so.5
            ${QT_LIBS_PATH}/libQt53DQuickInput.so.5
            ${QT_LIBS_PATH}/libQt53DQuickRender.so.5
            ${QT_LIBS_PATH}/libQt53DRender.so.5
            ${QT_LIBS_PATH}/libQt5Concurrent.so.5
            ${QT_LIBS_PATH}/libQt5Gamepad.so.5
            ${QT_LIBS_PATH}/libQt5PrintSupport.so.5)
    endif()
    
    set(_resolved_qtlibs_FILES "")
    foreach (_file ${qtlibs_FILES})
        file(GLOB _files "${_file}*")
        list(FILTER _files EXCLUDE REGEX ".debug")
        list (APPEND _resolved_qtlibs_FILES "${_files}")
    endforeach()
    install(FILES ${_resolved_qtlibs_FILES} DESTINATION ${INSTALLROOT}/${LIBSDIR})

    # Qt plugins
    install(
        FILES 
            ${QT_PLUGINS_PATH}/platforms/libqlinuxfb.so
            ${QT_PLUGINS_PATH}/platforms/libqxcb.so
            ${QT_PLUGINS_PATH}/platforms/libqminimal.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/platforms
    )

    install(
        FILES
            ${QT_PLUGINS_PATH}/xcbglintegrations/libqxcb-glx-integration.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/xcbglintegrations
    )

    install(
        FILES
            ${QT_PLUGINS_PATH}/audio/libqtaudio_alsa.so
            ${QT_PLUGINS_PATH}/audio/libqtmedia_pulse.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/audio
    )

    install(
        FILES
            ${QT_PLUGINS_PATH}/mediaservice/libgstaudiodecoder.so
            ${QT_PLUGINS_PATH}/mediaservice/libgstmediaplayer.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/mediaservice
    )

    install(
        FILES
            ${QT_PLUGINS_PATH}/imageformats/libqsvg.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/imageformats
    )

    if(qmlui)
        install(
            FILES
                ${QT_PLUGINS_PATH}/printsupport/libcupsprintersupport.so
            DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/printsupport
        )

        install(
            FILES
                ${QT_PLUGINS_PATH}/sceneparsers/libassimpsceneimport.so
            OPTIONAL DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/sceneparsers
        )

        install(
            FILES
                ${QT_PLUGINS_PATH}/geometryloaders/libdefaultgeometryloader.so
            DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/geometryloaders
        )
    endif()

    if(QT_VERSION VERSION_GREATER_EQUAL 5.15.0)
        install(FILES ${QT_PLUGINS_PATH}/renderers/libopenglrenderer.so DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/renderers)
    endif()

    set(qmldeps_files
        ${QT_QML_PATH}/QtQml
        ${QT_QML_PATH}/QtQuick
        ${QT_QML_PATH}/QtQuick.2
        ${QT_QML_PATH}/Qt3D
        ${QT_QML_PATH}/QtMultimedia
    )
    install(DIRECTORY ${qmldeps_files} DESTINATION ${INSTALLROOT}/bin)

endif()

=== platforms/macos/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(icons VERSION 1.0 LANGUAGES C CXX)

#set(CMAKE_INCLUDE_CURRENT_DIR ON)
include(../../variables.cmake)

# install macOS files for a correct bundle
install(FILES qt.conf DESTINATION ${INSTALLROOT}/${DATADIR})
install(FILES ../../resources/icons/qlcplus.icns DESTINATION ${INSTALLROOT}/${DATADIR})

if(qmlui)
    install(FILES Info.plist.qmlui DESTINATION ${INSTALLROOT}/Info.plist)
else()
    install(FILES Info.plist DESTINATION ${INSTALLROOT})
endif()
install(CODE "execute_process(COMMAND sed -i -e \"s/__QLC_VERSION__/${APPVERSION}/g\" ${INSTALLROOT}/Info.plist)")

set(APPLE_CODESIGN_ENTITLEMENTS "qlcplus.entitlements")

# Starting with arm64 macOS Apple will require ad-hoc code signatures,
# which can be generated by setting the identity to a single dash (-).
# These only include a checksum for verifying integrity, not an actual
# signature.
#if(NOT APPLE_CODESIGN_IDENTITY)
#    set(APPLE_CODESIGN_IDENTITY -)
#endif()

# install Qt library frameworks
#set(QT_FRAMEWORKS_DIR ${_qt5_root_dir}/../../Frameworks) # homebrew
set(QT_FRAMEWORKS_DIR $ENV{QTDIR}/lib)
set(QT_FRAMEWORK_NAMES
    "QtCore"
    "QtDBus"
    "QtGui"
    "QtMultimedia"
    "QtMultimediaWidgets"
    "QtNetwork"
    "QtOpenGL"
    "QtPrintSupport"
    "QtSerialPort"
    "QtSvg"
    "QtWidgets"
    "QtWebSockets"
)
if(QT_MAJOR_VERSION GREATER 5)
    list(APPEND QT_FRAMEWORK_NAMES "QtQml")
else()
    list(APPEND QT_FRAMEWORK_NAMES "QtScript")
endif()

# Loop through each framework and copy it to installation
foreach(FW_NAME IN LISTS QT_FRAMEWORK_NAMES)
    # install each framework Version file
    install(DIRECTORY ${QT_FRAMEWORKS_DIR}/${FW_NAME}.framework
            DESTINATION ${INSTALLROOT}/${LIBSDIR}
            PATTERN "Headers" EXCLUDE)
endforeach()

# install Qt plugins
set(QT_PLUGINS_DIR $ENV{QTDIR}/plugins)
# imageformats
install(FILES ${QT_PLUGINS_DIR}/imageformats/libqgif.dylib DESTINATION ${INSTALLROOT}/${PLUGINDIR}/imageformats)
install(FILES ${QT_PLUGINS_DIR}/imageformats/libqjpeg.dylib DESTINATION ${INSTALLROOT}/${PLUGINDIR}/imageformats)
install(FILES ${QT_PLUGINS_DIR}/imageformats/libqsvg.dylib DESTINATION ${INSTALLROOT}/${PLUGINDIR}/imageformats)
# multimedia
if(QT_MAJOR_VERSION GREATER 5)
    install(FILES ${QT_PLUGINS_DIR}/multimedia/libffmpegmediaplugin.dylib DESTINATION ${INSTALLROOT}/${PLUGINDIR}/multimedia)
    install(FILES ${QT_PLUGINS_DIR}/multimedia/libffmpegmediaplugin.dylib DESTINATION ${INSTALLROOT}/${PLUGINDIR}/multimedia)
else()
    install(FILES ${QT_PLUGINS_DIR}/mediaservice/libqavfmediaplayer.dylib DESTINATION ${INSTALLROOT}/${PLUGINDIR}/mediaservice)
    install(FILES ${QT_PLUGINS_DIR}/mediaservice/libqtmedia_audioengine.dylib DESTINATION ${INSTALLROOT}/${PLUGINDIR}/mediaservice)
endif()
# platforms
install(FILES ${QT_PLUGINS_DIR}/platforms/libqcocoa.dylib DESTINATION ${INSTALLROOT}/${PLUGINDIR}/platforms)
# styles
install(FILES ${QT_PLUGINS_DIR}/styles/libqmacstyle.dylib DESTINATION ${INSTALLROOT}/${PLUGINDIR}/styles)

# install support libraries
set(FFTW_LIBNAME "libfftw3.3.dylib")
set(OGG_LIBNAME "libogg.0.dylib")
set(FLAC_LIBNAME "libFLAC.12.dylib")
set(OPUS_LIBNAME "libopus.0.dylib")
set(MPG123_LIBNAME "libmpg123.0.dylib")
set(LAME_LIBNAME "libmp3lame.0.dylib")
set(VORBIS_LIBNAME "libvorbis.0.dylib")
set(VORBISENC_LIBNAME "libvorbisenc.2.dylib")

install(FILES ${FFTW3_LIBDIR}/${FFTW_LIBNAME} DESTINATION ${INSTALLROOT}/${LIBSDIR})
install(FILES ${LIBFTDI1_libftdi1_LIBDIR}/libftdi1.2.dylib DESTINATION ${INSTALLROOT}/${LIBSDIR})
install(FILES ${LIBFTDI1_libftdi1_LIBDIR}/libftdi1.2.5.0.dylib DESTINATION ${INSTALLROOT}/${LIBSDIR})
install(FILES ${LIBUSB1_LIBDIR}/libusb-1.0.0.dylib DESTINATION ${INSTALLROOT}/${LIBSDIR})
install(FILES ${MAD_LIBDIR}/libmad.0.dylib DESTINATION ${INSTALLROOT}/${LIBSDIR})
install(FILES ${SNDFILE_LIBDIR}/libsndfile.1.dylib DESTINATION ${INSTALLROOT}/${LIBSDIR})
install(FILES ${SNDFILE_LIBDIR}/libsndfile.1.0.37.dylib DESTINATION ${INSTALLROOT}/${LIBSDIR})

=== platforms/windows/CMakeLists.txt ===
project(windows)
# Set QT version
if(QT_MAJOR_VERSION GREATER 5)
    set(QT_V "Qt6")
    set(QT_P "qt6")
else()
    set(QT_V "Qt5")
    set(QT_P "qt5")
endif()

# Set paths
# message("${QT_LIBRARY_DIR}")
get_filename_component(QT_LIBS_PATH ${QT_DIR}/../../../bin ABSOLUTE)
get_filename_component(QT_PLUGINS_PATH ${QT_LIBS_PATH}/../share/${QT_P}/plugins ABSOLUTE)
get_filename_component(QT_QML_PATH ${QT_LIBS_PATH}/../share/${QT_P}/qml ABSOLUTE)
if ($ENV{MSYSTEM_CARCH} STREQUAL "i686")
    set(SYS_LIBS_PATH $ENV{SystemDrive}/msys64/mingw32/bin)
else()
    set(SYS_LIBS_PATH $ENV{SystemDrive}/msys64/mingw64/bin)
endif()
# set(SYS_LIBS_PATH D:/msys64/mingw32/bin)

# Qt library dependencies
set(qtdeps_path "${INSTALLROOT}/${LIBSDIR}")
set(qtdeps_files
    "${SYS_LIBS_PATH}/libbz2-1.dll"
    "${SYS_LIBS_PATH}/libfreetype-6.dll"
    "${SYS_LIBS_PATH}/libglib-2.0-0.dll"
    "${SYS_LIBS_PATH}/libgraphite2.dll"
    "${SYS_LIBS_PATH}/libharfbuzz-0.dll"
    "${SYS_LIBS_PATH}/libdouble-conversion.dll"
    "${SYS_LIBS_PATH}/libiconv-2.dll"
    "${SYS_LIBS_PATH}/libintl-8.dll"
    "${SYS_LIBS_PATH}/libpcre2-8-0.dll"
    "${SYS_LIBS_PATH}/libpcre2-16-0.dll"
    "${SYS_LIBS_PATH}/libpcre-1.dll"
    "${SYS_LIBS_PATH}/libpng16-16.dll"
    "${SYS_LIBS_PATH}/libjpeg-8.dll"
    "${SYS_LIBS_PATH}/libspeex-1.dll"
    "${SYS_LIBS_PATH}/libzstd.dll"
    "${SYS_LIBS_PATH}/libbrotlidec.dll"
    "${SYS_LIBS_PATH}/libbrotlicommon.dll"
    "${SYS_LIBS_PATH}/zlib1.dll"
)

if(qmlui)
	list(APPEND qtdeps_files 
		"${SYS_LIBS_PATH}/libassimp-5.dll"
		"${SYS_LIBS_PATH}/libminizip-1.dll")
endif()

if(QT_MAJOR_VERSION GREATER 5)
    list(APPEND qtdeps_files "${SYS_LIBS_PATH}/libb2-1.dll")
endif()
install(FILES ${qtdeps_files} OPTIONAL DESTINATION ${qtdeps_path})

set(qtlibs_path "${INSTALLROOT}/${LIBSDIR}")
set(qtlibs_files
    "${QT_LIBS_PATH}/${QT_V}Core.dll"
    "${QT_LIBS_PATH}/${QT_V}Network.dll"
    "${QT_LIBS_PATH}/${QT_V}Gui.dll"
    "${QT_LIBS_PATH}/${QT_V}Svg.dll"
    "${QT_LIBS_PATH}/${QT_V}Widgets.dll"
    "${QT_LIBS_PATH}/${QT_V}OpenGL.dll"
    "${QT_LIBS_PATH}/${QT_V}Multimedia.dll"
    "${QT_LIBS_PATH}/${QT_V}MultimediaWidgets.dll"
    "${QT_LIBS_PATH}/${QT_V}SerialPort.dll"
    "${QT_LIBS_PATH}/${QT_V}WebSockets.dll"
)
if(QT_MAJOR_VERSION GREATER 5)
    list(APPEND qtlibs_files "${QT_LIBS_PATH}/${QT_V}Qml.dll")
else()
    list(APPEND qtlibs_files "${QT_LIBS_PATH}/${QT_V}Script.dll")
endif()
if(qmlui)
    list(APPEND qtlibs_files
        "${QT_LIBS_PATH}/${QT_V}Qml.dll"
        "${QT_LIBS_PATH}/${QT_V}QmlModels.dll"
        "${QT_LIBS_PATH}/${QT_V}QmlWorkerScript.dll"
        "${QT_LIBS_PATH}/${QT_V}Quick.dll"
        "${QT_LIBS_PATH}/${QT_V}QuickControls2.dll"
        "${QT_LIBS_PATH}/${QT_V}QuickTemplates2.dll"
        "${QT_LIBS_PATH}/${QT_V}Sql.dll"
        "${QT_LIBS_PATH}/${QT_V}3DCore.dll"
        "${QT_LIBS_PATH}/${QT_V}3DExtras.dll"
        "${QT_LIBS_PATH}/${QT_V}3DInput.dll"
        "${QT_LIBS_PATH}/${QT_V}3DLogic.dll"
        "${QT_LIBS_PATH}/${QT_V}3DAnimation.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuick.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuickExtras.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuickInput.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuickAnimation.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuickRender.dll"
        "${QT_LIBS_PATH}/${QT_V}3DRender.dll"
        "${QT_LIBS_PATH}/${QT_V}Concurrent.dll"
        "${QT_LIBS_PATH}/${QT_V}Gamepad.dll"
        "${QT_LIBS_PATH}/${QT_V}PrintSupport.dll"
        "${QT_LIBS_PATH}/${QT_V}MultimediaQuick.dll"
    )
endif()
install(FILES ${qtlibs_files} DESTINATION ${qtlibs_path})

# Qt platform plugin
set(qtplatform_path "${INSTALLROOT}/${LIBSDIR}/platforms")
set(qtplatform_files "${QT_PLUGINS_PATH}/platforms/qwindows.dll")
install(FILES ${qtplatform_files} DESTINATION ${qtplatform_path})

# Qt styles plugin
set(qtstyles_path "${INSTALLROOT}/${LIBSDIR}/styles")
if(QT_MAJOR_VERSION GREATER 5)
    set(qtstyles_files "${QT_PLUGINS_PATH}/styles/qmodernwindowsstyle.dll")
else()
    set(qtstyles_files "${QT_PLUGINS_PATH}/styles/qwindowsvistastyle.dll")
endif()
install(FILES ${qtstyles_files} DESTINATION ${qtstyles_path})

if(QT_MAJOR_VERSION GREATER 5)
    set(qtmedia_path "${INSTALLROOT}/${LIBSDIR}/multimedia")
    set(qtmedia_files "${QT_PLUGINS_PATH}/multimedia/ffmpegmediaplugin.dll")
    install(FILES ${qtmedia_files} DESTINATION ${qtmedia_path})
else()
    set(qtaudio_path "${INSTALLROOT}/${LIBSDIR}/audio")
    set(qtaudio_files "${QT_PLUGINS_PATH}/audio/qtaudio_windows.dll")
    install(FILES ${qtaudio_files} DESTINATION ${qtaudio_path})

    set(qtmedia_path "${INSTALLROOT}/${LIBSDIR}/mediaservice")
    set(qtmedia_files "${QT_PLUGINS_PATH}/mediaservice/dsengine.dll"
                        "${QT_PLUGINS_PATH}/mediaservice/qtmedia_audioengine.dll")
    install(FILES ${qtmedia_files} DESTINATION ${qtmedia_path})
endif()

set(qtimageformats_path "${INSTALLROOT}/${LIBSDIR}/imageformats")
set(qtimageformats_files "${QT_PLUGINS_PATH}/imageformats/qgif.dll"
                          "${QT_PLUGINS_PATH}/imageformats/qjpeg.dll"
                          "${QT_PLUGINS_PATH}/imageformats/qsvg.dll")
install(FILES ${qtimageformats_files} DESTINATION ${qtimageformats_path})

if(qmlui)
    set(qtprintsupport_path "${INSTALLROOT}/${LIBSDIR}/printsupport")
    set(qtprintsupport_files "${QT_PLUGINS_PATH}/printsupport/windowsprintersupport.dll")
    install(FILES ${qtprintsupport_files} DESTINATION ${qtprintsupport_path})

    set(geometryloaders_path "${INSTALLROOT}/${LIBSDIR}/geometryloaders")
    set(geometryloaders_files "${QT_PLUGINS_PATH}/geometryloaders/defaultgeometryloader.dll")
    install(FILES ${geometryloaders_files} DESTINATION ${geometryloaders_path})

    set(sceneparsers_path "${INSTALLROOT}/${LIBSDIR}/sceneparsers")
    set(sceneparsers_files "${QT_PLUGINS_PATH}/sceneparsers/assimpsceneimport.dll")
    install(FILES ${sceneparsers_files} DESTINATION ${sceneparsers_path})

    set(renderers_path "${INSTALLROOT}/${LIBSDIR}/renderers")
    set(renderers_files "${QT_PLUGINS_PATH}/renderers/openglrenderer.dll")
    install(FILES ${renderers_files} DESTINATION ${renderers_path})

    set(qmldeps_path "${INSTALLROOT}/${LIBSDIR}")
    set(qmldeps_files "${QT_QML_PATH}/Qt"
                       "${QT_QML_PATH}/QtQml"
                       "${QT_QML_PATH}/QtQuick"
                       "${QT_QML_PATH}/QtQuick.2"
                       "${QT_QML_PATH}/Qt3D"
                       "${QT_QML_PATH}/QtMultimedia")
    install(DIRECTORY ${qmldeps_files} DESTINATION ${qmldeps_path})

    set(qmlpostinstall_commands "
        cd ${INSTALLROOT}/${LIBSDIR} && \
        find . -name plugins.qmltypes -type f -delete && \
        find . -name *.qmlc -type f -delete && \
        rm -rf Qt/WebSockets Qt/labs/location QtQml/RemoteObjects \
        rm -rf QtQuick/Extras QtQuick/Particles.2 QtQuick/XmlListModel \
        rm -rf QtQuick/Controls.2/designer QtQuick/Controls.2/Material \
        rm -rf QtQuick/Controls.2/Universal QtQuick/Controls.2/Fusion \
        rm -rf QtQuick/Controls.2/Imagine QtQuick/Scene2D
    ")
    install(CODE "execute_process(COMMAND ${qmlpostinstall_commands})")
endif()

function(copy_system_library target libname)
	if(EXISTS ${SYS_LIBS_PATH}/${libname})
		list(APPEND ${target} ${SYS_LIBS_PATH}/${libname})
		set(${target} "${${target}}" PARENT_SCOPE)
    else()
        message(FATAL_ERROR "ERROR: missing DLL detected: ${libname}")
	endif()
endfunction()

# MSYS2 libraries
set(msys_path "${INSTALLROOT}/${LIBSDIR}")
copy_system_library(msys_files "libstdc++-6.dll")
copy_system_library(msys_files "libwinpthread-1.dll")
copy_system_library(msys_files "libicuin76.dll")
copy_system_library(msys_files "libicuuc76.dll")
copy_system_library(msys_files "libicudt76.dll")
copy_system_library(msys_files "libmd4c.dll")
copy_system_library(msys_files "libusb-1.0.dll")

if ($ENV{MSYSTEM_CARCH} STREQUAL "i686")
    copy_system_library(msys_files "libgcc_s_dw2-1.dll")
else()
    copy_system_library(msys_files "libgcc_s_seh-1.dll")
endif()

install(FILES ${msys_files} DESTINATION ${msys_path})

# audio libraries
set(mmedia_path "${INSTALLROOT}/${LIBSDIR}")
copy_system_library(mmedia_files "libmad-0.dll")
copy_system_library(mmedia_files "libogg-0.dll")
copy_system_library(mmedia_files "libopus-0.dll")
copy_system_library(mmedia_files "libmp3lame-0.dll")
copy_system_library(mmedia_files "libmpg123-0.dll")
copy_system_library(mmedia_files "libvorbis-0.dll")
copy_system_library(mmedia_files "libvorbisenc-2.dll")
copy_system_library(mmedia_files "libFLAC.dll")
copy_system_library(mmedia_files "libsndfile-1.dll")
copy_system_library(mmedia_files "libfftw3-3.dll")
 
if(QT_MAJOR_VERSION GREATER 5)
	copy_system_library(mmedia_files "avformat-61.dll")
	copy_system_library(mmedia_files "avutil-59.dll")
	copy_system_library(mmedia_files "avcodec-61.dll")
	copy_system_library(mmedia_files "libbluray-2.dll")
	copy_system_library(mmedia_files "libgme.dll")
	copy_system_library(mmedia_files "libgnutls-30.dll")
	copy_system_library(mmedia_files "libmodplug-1.dll")
	copy_system_library(mmedia_files "librtmp-1.dll")
	copy_system_library(mmedia_files "libsrt.dll")
	copy_system_library(mmedia_files "libssh.dll")
	copy_system_library(mmedia_files "libdav1d-7.dll")
	copy_system_library(mmedia_files "libaom.dll")
	copy_system_library(mmedia_files "libcairo-2.dll")
	copy_system_library(mmedia_files "libgobject-2.0-0.dll")
	copy_system_library(mmedia_files "libgsm.dll")
	copy_system_library(mmedia_files "libjxl_threads.dll")
	copy_system_library(mmedia_files "libjxl.dll")
	copy_system_library(mmedia_files "liblzma-5.dll")
	copy_system_library(mmedia_files "liblc3-1.dll")
	copy_system_library(mmedia_files "libxml2-2.dll")
	copy_system_library(mmedia_files "libva.dll")
	copy_system_library(mmedia_files "libvpl-2.dll")
	copy_system_library(mmedia_files "libva_win32.dll")
	copy_system_library(mmedia_files "swscale-8.dll")
	copy_system_library(mmedia_files "swresample-5.dll")
	copy_system_library(mmedia_files "libopencore-amrnb-0.dll")
	copy_system_library(mmedia_files "libopencore-amrwb-0.dll")
	copy_system_library(mmedia_files "libopenjp2-7.dll")
	copy_system_library(mmedia_files "librav1e.dll")
	copy_system_library(mmedia_files "librsvg-2-2.dll")
	copy_system_library(mmedia_files "libtheoradec-1.dll")
	copy_system_library(mmedia_files "libSvtAv1Enc-2.dll")
	copy_system_library(mmedia_files "libtheoraenc-1.dll")
	copy_system_library(mmedia_files "libvpx-1.dll")
	copy_system_library(mmedia_files "libwebp-7.dll")
	copy_system_library(mmedia_files "libwebpmux-3.dll")
	copy_system_library(mmedia_files "libx265-215.dll")
	copy_system_library(mmedia_files "libx264-164.dll")
	copy_system_library(mmedia_files "xvidcore.dll")
	copy_system_library(mmedia_files "libzvbi-0.dll")
	copy_system_library(mmedia_files "libbrotlienc.dll")
	copy_system_library(mmedia_files "libgmp-10.dll")
	copy_system_library(mmedia_files "libhogweed-6.dll")
	copy_system_library(mmedia_files "libidn2-0.dll")
	copy_system_library(mmedia_files "libp11-kit-0.dll")
	copy_system_library(mmedia_files "libtasn1-6.dll")
	copy_system_library(mmedia_files "libunistring-5.dll")
	copy_system_library(mmedia_files "libnettle-8.dll")
	copy_system_library(mmedia_files "libcrypto-3-x64.dll")
	copy_system_library(mmedia_files "libfontconfig-1.dll")
	copy_system_library(mmedia_files "libpixman-1-0.dll")
	copy_system_library(mmedia_files "libffi-8.dll")
	copy_system_library(mmedia_files "libhwy.dll")
	copy_system_library(mmedia_files "libjxl_cms.dll")
	copy_system_library(mmedia_files "libsoxr.dll")
	copy_system_library(mmedia_files "libgdk_pixbuf-2.0-0.dll")
	copy_system_library(mmedia_files "libcairo-gobject-2.dll")
	copy_system_library(mmedia_files "libgio-2.0-0.dll")
	copy_system_library(mmedia_files "libpango-1.0-0.dll")
	copy_system_library(mmedia_files "libpangocairo-1.0-0.dll")
	copy_system_library(mmedia_files "libsharpyuv-0.dll")
	copy_system_library(mmedia_files "libexpat-1.dll")

=== plugins/enttecwing/CMakeLists.txt ===
project(enttecwing)

add_subdirectory(src)
add_subdirectory(test)

=== plugins/velleman/CMakeLists.txt ===
project(velleman)

add_subdirectory(src)
add_subdirectory(test)

=== resources/colorfilters/CMakeLists.txt ===
project(colorfilters)

file(GLOB COLOR_FILTER_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.qxcf")

if(ANDROID)
    set(COLOR_FILTERS_ASSETS_DIR "${ANDROID_PACKAGE_SOURCE_DIR}/${COLORFILTERSDIR}")
    # Create the assets directory if it doesn't exist
    file(MAKE_DIRECTORY ${COLOR_FILTERS_ASSETS_DIR})

    # Copy the color filter files to the assets directory
    foreach(COLOR_FILTER_FILE ${COLOR_FILTER_FILES})
        file(COPY ${COLOR_FILTER_FILE} DESTINATION ${COLOR_FILTERS_ASSETS_DIR})
    endforeach()
endif()

install(FILES ${COLOR_FILTER_FILES} DESTINATION ${INSTALLROOT}/${COLORFILTERSDIR})

=== resources/meshes/CMakeLists.txt ===
project(meshes)

add_subdirectory(fixtures)
add_subdirectory(generic)
add_subdirectory(stage)

=== webaccess/src/CMakeLists.txt ===
set(module_name "qlcpluswebaccess")

include(../../variables.cmake)

set(TS_FILES
    webaccess_fi_FI.ts
    webaccess_de_DE.ts
    webaccess_fr_FR.ts
    webaccess_es_ES.ts
    webaccess_it_IT.ts
    webaccess_nl_NL.ts
    webaccess_cz_CZ.ts
    webaccess_pt_BR.ts
    webaccess_ca_ES.ts
    webaccess_ja_JP.ts
)

if(QT_VERSION_MAJOR GREATER 5)
    qt_add_translation(QM_FILES ${TS_FILES})
else()
    qt5_add_translation(QM_FILES ${TS_FILES})
endif()

add_library(${module_name}
    SHARED
    commonjscss.h
    qhttpserver/http_parser.c qhttpserver/http_parser.h
    qhttpserver/qhttpconnection.cpp qhttpserver/qhttpconnection.h
    qhttpserver/qhttprequest.cpp qhttpserver/qhttprequest.h
    qhttpserver/qhttpresponse.cpp qhttpserver/qhttpresponse.h
    qhttpserver/qhttpserver.cpp qhttpserver/qhttpserver.h
    qhttpserver/qhttpserverfwd.h
    webaccess.cpp webaccess.h
    webaccessauth.cpp webaccessauth.h
    webaccessconfiguration.cpp webaccessconfiguration.h
    webaccesssimpledesk.cpp webaccesssimpledesk.h
    ${QM_FILES}
)

target_include_directories(${module_name} PUBLIC
    ../../engine/audio/src
    ../../engine/src
    ../../ui/src
    ../../ui/src/virtualconsole
    qhttpserver
)

target_compile_definitions(${module_name} PUBLIC
    NO_SSL
    USE_WEBSOCKET
)

find_package(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS WebSockets)

target_link_libraries(${module_name} PUBLIC
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Multimedia
    Qt${QT_MAJOR_VERSION}::Network
    Qt${QT_MAJOR_VERSION}::Widgets
    Qt${QT_MAJOR_VERSION}::WebSockets
    qlcplusengine
    qlcplusui
)

if(qmlui OR (QT_VERSION_MAJOR GREATER 5))
    target_link_libraries(${module_name} PUBLIC
        Qt${QT_MAJOR_VERSION}::Qml
    )
endif()

if(NOT (qmlui OR (QT_VERSION_MAJOR GREATER 5)))
    target_link_libraries(${module_name} PUBLIC
        Qt${QT_MAJOR_VERSION}::Script
    )
endif()

if(WIN32)
    target_include_directories(${module_name} PUBLIC /)
    target_link_libraries(${module_name} PUBLIC ws2_32)
endif()

if(UNIX AND NOT APPLE)
    target_sources(${module_name} PRIVATE
        webaccessnetwork.cpp webaccessnetwork.h
    )
endif()


install(TARGETS ${module_name}
    LIBRARY DESTINATION ${INSTALLROOT}/${LIBSDIR}
    RUNTIME DESTINATION ${INSTALLROOT}/${LIBSDIR}
)

=== engine/audio/plugins/CMakeLists.txt ===
project(plugins)

if((((NOT ANDROID AND NOT IOS))))
    pkg_check_modules(MAD IMPORTED_TARGET mad)
    if(${MAD_FOUND})
        add_subdirectory(mad)
    endif()

    pkg_check_modules(SNDFILE IMPORTED_TARGET sndfile)
    if(${SNDFILE_FOUND})
        add_subdirectory(sndfile)
    endif()
endif()

=== engine/test/collection/CMakeLists.txt ===
add_executable(collection_test WIN32
    ../mastertimer/mastertimer_stub.cpp ../mastertimer/mastertimer_stub.h
    collection_test.cpp collection_test.h
)
target_include_directories(collection_test PRIVATE
    ../../../plugins/interfaces
    ../../src
    ../mastertimer
)

target_link_libraries(collection_test PRIVATE
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Test
    qlcplusengine
)

# Consider using qt_generate_deploy_app_script() for app deployment if
# the project can use Qt 6.3. In that case rerun qmake2cmake with
# --min-qt-version=6.3.

=== debian/changelog ===
qlcplus (4.14.1-1) unstable; urgency=medium

  * New upstream version 4.14.1
  * d/control: Bump Standards-Versions to 4.7.2

 -- Jerome Lebleu <jerome@maroufle.fr>  Sun, 23 Mar 2025 19:06:50 +0100

=== debian/control ===
Source: qlcplus
Section: misc
Priority: optional
Maintainer: Jerome Lebleu <jerome@maroufle.fr>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libasound2-dev (>= 1.0.16),
               libfftw3-dev,
               libftdi1-dev,
               libmad0-dev,
               libqt5serialport5-dev,
               libqt5svg5-dev,
               libqt5websockets5-dev,
               libsndfile1-dev,
               libudev-dev,
               libusb-1.0-0-dev (>= 2:0.1.12),
               libxml2-utils,
               localehelper <!nocheck>,
               pkgconf,
               python3,
               python3-lxml,
               qtdeclarative5-dev,
               qtmultimedia5-dev,
               qtscript5-dev,
               qttools5-dev,
               shared-mime-info (>= 0.71),
               systemd-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>
Standards-Version: 4.7.2
Homepage: https://www.qlcplus.org/
Vcs-Git: https://salsa.debian.org/jlebleu/qlcplus.git
Vcs-Browser: https://salsa.debian.org/jlebleu/qlcplus
Rules-Requires-Root: no

Package: qlcplus
Architecture: any
Depends: qlcplus-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: libmad0, libqt5multimedia5-plugins, libsndfile1
Description: Control DMX or analog lighting systems
 Q Light Controller Plus is a software lighting desk for controlling
 DMX or analog lighting systems like moving heads, dimmers, scanners.
 .
 This project is a fork of the great QLC project written by Heikki Junnila
 that aims to continue the QLC development and to introduce new features. The
 primary goal is to bring QLC+ at the level of other lighting control commercial
 software.

Package: qlcplus-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Control DMX or analog lighting systems (data files)
 Q Light Controller Plus is a software lighting desk for controlling
 DMX or analog lighting systems like moving heads, dimmers, scanners.
 .
 This project is a fork of the great QLC project written by Heikki Junnila
 that aims to continue the QLC development and to introduce new features. The
 primary goal is to bring QLC+ at the level of other lighting control commercial
 software.
 .
 This package contains architecture-independent data files.
